// ProgErr.c 
// ProgramError function

#include <stdio.h>
#include <windows.h>

///////////////////////////////////////
// Program_error Message
// Display the specified condition, a 
// message from the programmer, the file 
// name the line number in a message box.
void Program_error(char* cond, 
                   char* message, 
                   char* fileName, 
                   int   lineNumber)
  {
  // Use local buffers to make sure no 
  // overruns occure.
  char theCondition[100]; 
  char theFile[100];
  char theMessage[256];
  char errorMessage[559];

  strncpy(theCondition, cond, sizeof(theCondition));
  strncpy(theFile, fileName, sizeof(theFile));
  strncpy(theMessage, message, sizeof(theMessage));
  
  sprintf(errorMessage, 
    "Program Error: %s - %s\nFile: %s, "
    "Line: %d\n\nExit Program?", 
    theCondition, theMessage, theFile, lineNumber);
    
  if(MessageBox(NULL, errorMessage, 
     "Program Error", MB_YESNO) == IDYES) 
    {   
    exit(EXIT_FAILURE);
    }
  } // end of function.



